# set PCRE to get the source directory inc
#PCRE = 1

!include watoptions.inc

INCLUDE = .\;$(COMINC)

SRCS = pcre_chartables.c pcre_compile.c pcre_config.c pcre_dfa_exec.c &
       pcre_exec.c pcre_fullinfo.c pcre_get.c pcre_globals.c pcre_info.c &
       pcre_maketables.c pcre_ord2utf8.c pcre_refcount.c pcre_study.c &
       pcre_tables.c pcre_try_flipped.c pcre_ucp_searchfuncs.c &
       pcre_valid_utf8.c pcre_version.c pcre_xclass.c

OBJS = pcre_chartables.obj pcre_compile.obj pcre_config.obj pcre_dfa_exec.obj &
       pcre_exec.obj pcre_fullinfo.obj pcre_get.obj pcre_globals.obj pcre_info.obj &
       pcre_maketables.obj pcre_ord2utf8.obj pcre_refcount.obj pcre_study.obj &
       pcre_tables.obj pcre_try_flipped.obj pcre_ucp_searchfuncs.obj &
       pcre_valid_utf8.obj pcre_version.obj pcre_xclass.obj

SRC2 = pcreposix.c

OBJ2 = pcreposix.obj

RELEASEDIR = .\Release

all: libs dll .SYMBOLIC

libs: pcre.lib pcreposix.lib pcretest.exe pcregrep.exe .SYMBOLIC

dll:  pcre.dll pcretest2.exe pcregrep2.exe .SYMBOLIC

#apr build
build: pcre.dll release .SYMBOLIC

release: .SYMBOLIC
  -@copy pcre.dll  $(RELEASEDIR)\dll
  -@copy ipcre.lib $(RELEASEDIR)\lib
  -@copy pcre.h $(RELEASEDIR)\include
  -@copy pcreposix.h $(RELEASEDIR)\include

pcre.lib: dftables.exe
  $(CC) -c -DPOSIX_MALLOC_THRESHOLD=10 $(CFLAGS) $(SRCS)
  $(LB) $(LIBFLAGS) pcre.lib $(OBJS)

pcreposix.lib:
  $(CC) -c -DPOSIX_MALLOC_THRESHOLD=10 $(CFLAGS) $(SRC2)
  $(LB) $(LIBFLAGS) pcreposix.lib $(OBJ2)

dftables.exe:
  $(CC) $(CFLAGS) dftables.c
  dftables.exe pcre_chartables.c

pcretest.exe: pcre.lib pcreposix.lib
  $(CC) -c $(CFLAGS) pcretest.c
  $(LD) NAME pcretest SYSTEM $(SYSLINK) $(LDFLAGS) op st=0x400000 &
   LIB {pcre.lib pcreposix.lib} FILE pcretest.obj

pcregrep.exe: pcre.lib
  $(CC) -c -DHAVE_OWATCOM $(CFLAGS) pcregrep.c
  $(LD) NAME pcregrep SYSTEM $(SYSLINK) $(LDFLAGS) LIB {pcre.lib} FILE pcregrep.obj

pcre.dll: dftables.exe
  -@rm *.obj
  $(CC) -c -DPOSIX_MALLOC_THRESHOLD=10 -DOS2DLL $(CFLAGS) $(DLLOPT) $(SRCS) $(SRC2)
  $(LD) NAME pcre @pcre.lnk $(LDFLAGS) FILE {$(OBJS) $(OBJ2)}
  $(LB) $(LIBFLAGS) ipcre.lib +pcre.dll

pcretest2.exe: pcre.dll
  $(CC) -c $(CFLAGS) pcretest.c
  $(LD) NAME pcretest2 SYSTEM $(SYSLINK) $(LDFLAGS) op st=0x400000 LIB ipcre.lib FILE pcretest.obj

pcregrep2.exe: pcre.dll
  $(CC) -c -DHAVE_OWATCOM $(CFLAGS) pcregrep.c
  $(LD) NAME pcregrep2 SYSTEM $(SYSLINK) $(LDFLAGS) LIB ipcre.lib FILE pcregrep.obj

clean : .SYMBOLIC
  -@rm *.obj
  -@rm *.err
  -@rm *.lst
  -@rm *.map

cleanall : .SYMBOLIC
  -@rm *.obj
  -@rm *.exe
  -@rm *.err
  -@rm *.lst
  -@rm *.map
  -@rm *.lib
  -@rm *.exe

